﻿
Imports System.Data.OleDb

Public Class FTestDB

    Dim MiConexion As New OleDbConnection
    Dim MisDatos As New DataSet
    Dim NombreTablaEnDB As String
    Dim MiComando As New OleDbCommand

    Dim CargaArticleCompleta As Boolean = False   ' Para evitar los procedimientos que dan errores si activados durante la carga.

    Private Sub FTestDB_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '
    End Sub

    Private Sub BCargarAdapter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BCargarAdapter.Click
        CargarLaTablaConAdapter()
    End Sub

    Private Sub ParametroConexion()

        'Dim RutaYNombreDB As String = "D:\Tmp\TestAccesDBSimpleConMostrar\MonStock2003.mdb"  
        'MiConexion.ConnectionString = "Provider=Microsoft.JET.OLEDB.4.0;Data Source=" & RutaYNombreDB & ";"  ' Exécuter en x86

        Dim RutaYNombreDB As String = "D:\Tmp\TestAccesDBSimpleConMostrar\MonStock2013.accdb"
             MiConexion.ConnectionString = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & RutaYNombreDB & ";"  ' Ejecutar en x64

        '       NombreTablaEnDB = "TProduit"   ' este es LaTablaQueMeGusta  
        NombreTablaEnDB = "TProduit2"   ' este es LaTablaQueMeGusta  
    End Sub

    Private Sub CargarLaTablaConAdapter() ' con DataAdapter   Este es mas simple porque la DataTabla es creada automaticamente

        If MisDatos.Tables.Count > 0 Then  ' Para muchas pruebas
            MisDatos.Tables.Clear()
        End If

        ParametroConexion()

        Dim UnaTabla As New DataTable
        Dim Consulta As String

        Consulta = "SELECT * FROM " & NombreTablaEnDB

        Dim MiAdapter As OleDbDataAdapter = New OleDbDataAdapter(Consulta, MiConexion)

        MiAdapter.Fill(UnaTabla)
        UnaTabla.TableName = NombreTablaEnDB
        MisDatos.Tables.Add(UnaTabla)

        MiAdapter.Dispose()

        MiConexion.Close()

        MostrarDatos()

    End Sub

    Private Sub MostrarDatos()

        For Each C As Control In Me.Controls  ' Para muchas pruebas, es necesario de borrar anticas enlaces
            Try
                C.DataBindings.Clear()
            Catch
            End Try
        Next

        ' DataGridView
        DGVTest.VirtualMode = True
        DGVTest.DataSource = MisDatos.Tables(NombreTablaEnDB)

        ' ComboBox
        CBTest.DataSource = MisDatos.Tables(NombreTablaEnDB)
        CBTest.DisplayMember = "Article"
        CBTest.ValueMember = "Stock"


        ' TextBox  !!! con este metodo, los TextBox siempre contienen los valores actuales
        '              el Sub CBTest_SelectedIndexChanged siguiente puede ser isolada
        TBDisplayCombo.DataBindings.Add("Text", MisDatos.Tables(NombreTablaEnDB), "Article")
        TBValueCombo.DataBindings.Add("Text", MisDatos.Tables(NombreTablaEnDB), "Stock")
        TBIdProducto.DataBindings.Add("Text", MisDatos.Tables(NombreTablaEnDB), "Id")

        CargaArticleCompleta = True

    End Sub

    'Private Sub CBTest_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CBTest.SelectedIndexChanged
    '    If Not CargaArticleCompleta Then
    '        Exit Sub
    '    End If
    '    TBDisplayCombo.Text = CBTest.Text
    '    TBValueCombo.Text = CBTest.SelectedValue
    'End Sub

    ' El bloque de gestión de lectura. Un solo procedimiente evento responde a 4 fuentes de Click : BPrimero, BAnterior, BSiguiente y BUltimo
    Private Sub LecturaCircular_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BUltimo.Click, BAnterior.Click, BSiguiente.Click, BPrimero.Click
        ' No es necesario intentar un movimiento si el DataSet no contiene ninguna tabla.
        If MisDatos.Tables.Count > 0 Then
            ' El BindingContext pertenece a un contenedor, el formulario en este caso.

            '' '' Las 2 lineas siguiente esta para evitar de registrar modificaciones accidentales. 
            '' '' No activadas aqui porque el objtecto de este ejemplo es de mostrar estos cambios.
            MisDatos.Tables(NombreTablaEnDB).RejectChanges()
            Me.BindingContext(MisDatos.Tables(NombreTablaEnDB)).CancelCurrentEdit()

            With Me.BindingContext(MisDatos.Tables(NombreTablaEnDB))
                ' Modificacion de la propiedad Position segun el boton seleccionado.
                Select Case sender.Name
                    Case "BPrimero"
                        .Position = 0
                    Case "BAnterior"
                        If .Position = 0 Then
                            .Position = .Count - 1              ' Lectura circular (como un reloj pero al revés)
                        Else
                            .Position -= 1
                        End If
                    Case "BSiguiente"
                        If .Position = .Count - 1 Then
                            .Position = 0                       ' Lectura circular (como un reloj)
                        Else
                            .Position += 1
                        End If
                    Case "BUltimo"
                        .Position = .Count - 1
                End Select
            End With
        End If
    End Sub

End Class

